



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CSS系列：CSS3新增选择器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CSS系列：CSS3新增选择器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:11:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1. CSS1定义的选择器</h1>
<table>
<tbody>
<tr>
<th>选择器</th>
<th>类型</th>
<th>说明</th>
</tr>
<tr>
<td>E</td>
<td>类型选择器</td>
<td>选择指定类型的元素</td>
</tr>
<tr>
<td>E#id</td>
<td>ID选择器</td>
<td>选择匹配E的元素，且匹配元素的id为&ldquo;id&rdquo;，E选择符可以省略。</td>
</tr>
<tr>
<td>E.class</td>
<td>类选择器</td>
<td>选择匹配E的元素，且匹配元素的class属性值为&ldquo;class&rdquo;，E选择符可以省略。</td>
</tr>
<tr>
<td>E F</td>
<td>包含选择器</td>
<td>选择匹配F的元素，且该元素被包含在匹配E的元素内。</td>
</tr>
<tr>
<td>E:link</td>
<td>链接伪类选择器</td>
<td>选择匹配E的元素，且匹配元素被定义了超链接并未被访问。例：a:link</td>
</tr>
<tr>
<td>E:visited</td>
<td>链接伪类选择器</td>
<td>选择匹配E的元素，且匹配元素被定义了超链接并已被访问。例：a:visited</td>
</tr>
<tr>
<td>E:active</td>
<td>用户操作伪类选择器</td>
<td>选择匹配E的元素，且匹配元素被激活</td>
</tr>
<tr>
<td>E:hover</td>
<td>用户操作伪类选择器</td>
<td>选择匹配E的元素，且匹配元素正被鼠标经过</td>
</tr>
<tr>
<td>E:focus</td>
<td>用户操作伪类选择器</td>
<td>选择匹配E的元素，且匹配元素获取了焦点</td>
</tr>
<tr>
<td>E::first-line</td>
<td>伪元素选择器</td>
<td>选择匹配E元素内的第一行文本</td>
</tr>
<tr>
<td>E::first-letter</td>
<td>伪元素选择器</td>
<td>选择匹配E元素内的第一个字符</td>
</tr>
</tbody>
</table>
<h1>2. CSS2定义的选择器</h1>
<table>
<tbody>
<tr>
<th>选择器</th>
<th>类型</th>
<th>说明</th>
</tr>
<tr>
<td>*</td>
<td>通配选择器</td>
<td>选择文档中所有元素</td>
</tr>
<tr>
<td>E[foo]</td>
<td>属性选择器</td>
<td>选择匹配E的元素，且该元素定义了foo属性。E选择符可以省略，表示选择定义了foo属性的任意类型的元素。</td>
</tr>
<tr>
<td>E[foo="bar"]</td>
<td>属性选择器</td>
<td>选择匹配E的元素，且该元素foo属性值为&ldquo;bar&rdquo;</td>
</tr>
<tr>
<td>E[foo~="bar"]</td>
<td>属性选择器</td>
<td>选择匹配E的元素，且该元素定义了foo属性，foo属性值是一个以空格符分隔的列表，其中一个列表的值为&ldquo;bar&rdquo;，E选择符可以省略。</td>
</tr>
<tr>
<td>E[foo!="en"]</td>
<td>属性选择器</td>
<td>选择匹配E的元素，且该元素定义了foo属性，foo属性值是一个用连字符（-）分隔的列表，值以&ldquo;en&rdquo;开头。</td>
</tr>
<tr>
<td>E:first-child</td>
<td>结构伪类选择器</td>
<td>选择匹配E的元素，且该元素为父元素的第一个子元素</td>
</tr>
<tr>
<td>E::before</td>
<td>伪元素选择器</td>
<td>在匹配E的元素前面插入内容</td>
</tr>
<tr>
<td>E::after</td>
<td>伪元素选择器</td>
<td>在匹配E的元素后面插入内容</td>
</tr>
<tr>
<td>E &gt; F</td>
<td>子包含选择器</td>
<td>选择匹配F的元素，且该元素为所匹配E元素的子元素。</td>
</tr>
<tr>
<td>E + F</td>
<td>相邻兄弟选择器</td>
<td>选择匹配F的元素，且该元素为所匹配E元素后面相邻的位置。</td>
</tr>
</tbody>
</table>
<h1>3. CSS3新增属性选择器</h1>
<table>
<tbody>
<tr>
<th>选择器</th>
<th>类型</th>
<th>说明</th>
</tr>
<tr>
<td>E[foo^="bar"]</td>
<td>属性选择器</td>
<td>选择匹配E的元素，且该元素定义了foo属性，foo属性值以&ldquo;bar&rdquo;开始。E选择符可以省略，表示可匹配任意类型的元素。</td>
</tr>
<tr>
<td>E[foo$="bar"]</td>
<td>属性选择器</td>
<td>选择匹配E的元素，且该元素定义了foo属性，foo属性值以&ldquo;bar&rdquo;结束。E选择符可以省略，表示可匹配任意类型的元素。</td>
</tr>
<tr>
<td>E[foo*="bar"]</td>
<td>属性选择器</td>
<td>选择匹配E的元素，且该元素定义了foo属性，foo属性值包含&ldquo;bar&rdquo;。E选择符可以省略，表示可匹配任意类型的元素。</td>
</tr>
</tbody>
</table>
<p>　　<em>示例</em></p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;

&lt;html&gt;<br />
&lt;head&gt;<br />
    &lt;meta name="viewport" content="width=device-width" /&gt;<br />
    &lt;title&gt;Index&lt;/title&gt;<br />
    &lt;style type="text/css"&gt;<br />
        body {<br />
            font-size: 12px;<br />
        }

        ul, li {<br />
            list-style: none;<br />
        }

        li {<br />
            height: 22px;<br />
            line-height: 22px;<br />
        }

        a {<br />
            text-decoration: none;<br />
            color: #E47911;<br />
        }

            a[href$="docx"] {<br />
                background: url(/Content/icon/word.png) no-repeat;<br />
                padding-left: 20px;<br />
            }

            a[href$="xlsx"] {<br />
                background: url(/Content/icon/excel.png) no-repeat;<br />
                padding-left: 20px;<br />
            }

            a[href$="pptx"] {<br />
                background: url(/Content/icon/powerpoint.png) no-repeat;<br />
                padding-left: 20px;<br />
            }

            a[href$="pst"] {<br />
                background: url(/Content/icon/outlook.png) no-repeat;<br />
                padding-left: 20px;<br />
            }<br />
    &lt;/style&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
    &lt;ul&gt;<br />
        &lt;li&gt;&lt;a href="Word文件.docx"&gt;Word文件&lt;/a&gt;&lt;/li&gt;<br />
        &lt;li&gt;&lt;a href="Excel文件.xlsx"&gt;Excel文件&lt;/a&gt;&lt;/li&gt;<br />
        &lt;li&gt;&lt;a href="PPT文件.pptx"&gt;PPT文件&lt;/a&gt;&lt;/li&gt;<br />
        &lt;li&gt;&lt;a href="Outlook文件.pst"&gt;Outlook文件&lt;/a&gt;&lt;/li&gt;<br />
    &lt;/ul&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>　　<em>效果</em></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/56886/201503/292255264743294.png" /></p>
<h1>4. 结构伪类选择器</h1>
<p>　　结构伪类利用DOM实现元素过滤，通过DOM的相互关系来匹配特定的元素，减少文档内对class属性和ID属性的定义，使得文档更加简洁。</p>
<table>
<tbody>
<tr>
<th>选择器</th>
<th>说明</th>
</tr>
<tr>
<td>E:root</td>
<td>选择匹配E所在文档的根元素。在（X）HTML文档中，根元素就是html元素，此时该选择器与html类型选择器匹配的内容相同。</td>
</tr>
<tr>
<td>E:nth-child(n)</td>
<td> 选择所有在其父元素中第n个位置的匹配E的子元素。<br />
                注意，参数n可以是数字（1、2、3）、关键字（odd、even）、公式（2n、2n+3）参数的索引从1开始。<br />
                tr:nth-child(3)匹配所有表格中第3排的tr；<br />
                tr:nth-child(2n+1)匹配所有表格的奇数行；<br />
                tr:nth-child(2n)匹配所有表格的偶数行；<br />
                tr:nth-child(odd)匹配所有表格的奇数行；<br />
                tr:nth-child(even)匹配所有表格的偶数行；
            </td>
</tr>
<tr>
<td>E:nth-last-child(n)</td>
<td>选择所有在其父元素中倒数第n个位置的匹配E的子元素</td>
</tr>
<tr>
<td>E:nth-of-type(n)</td>
<td>选择父元素中第n个位置，且匹配E的子元素。<br />
            注意，所有匹配E的子元素被分离出来单独排序。非E的子元素不参与排序。参数n可以是数字，关键字、公式。<br />
            例：p:nth-of-type(1)</td>
</tr>
<tr>
<td>E:nth-last-of-type(n)</td>
<td>选择父元素中倒数第n个位置，且匹配E的子元素。</td>
</tr>
<tr>
<td>E:last-child</td>
<td>选择位于其父元素中最后一个位置，且匹配E的子元素。</td>
</tr>
<tr>
<td>E:first-of-type</td>
<td>
                选择位于其父元素中且匹配E的第一个同类型的子元素。<br />
                该选择器的功能类似于 E:nth-of-type(1)
            </td>
</tr>
<tr>
<td>E:last-of-type</td>
<td>
                选择位于其父元素中且匹配E的最后第一个同类型的子元素。<br />
                该选择器的功能类似于 E:nth-last-of-type(1)
            </td>
</tr>
<tr>
<td>E:only-child</td>
<td>选择其父元素只包含一个子元素，且该子元素匹配E。</td>
</tr>
<tr>
<td>E:only-of-type</td>
<td>选择其父元素只包含一个同类型的子元素，且该子元素匹配E。</td>
</tr>
<tr>
<td>E:empty</td>
<td>选择匹配E的元素，且该元素不包含子节点。</td>
</tr>
</tbody>
</table>
<p>　　<em>示例</em></p>
<div>
<pre class="prettyprint linenums">&lt;style type="text/css"&gt;<br />
    table {<br />
        table-layout: fixed;<br />
        border-collapse: collapse;<br />
        empty-cells: show;<br />
    }

    tr:nth-child(even) {<br />
        background-color: #f5f5f5;<br />
    }<br />
&lt;/style&gt;</pre>
</div>
<p>　　<em>设置圆角</em></p>
<div>
<pre class="prettyprint linenums">.content {<br />
    border-radius: 5px;<br />
    -moz-border-radius: 5px;<br />
    -webkit-border-radius: 5px;<br />
}</pre>
</div>
<h1>5. UI状态伪类选择器</h1>
<table>
<tbody>
<tr>
<th>选择器</th>
<th>说明</th>
</tr>
<tr>
<td>E:enabled</td>
<td>选择匹配E的所有可用UI元素。</td>
</tr>
<tr>
<td>E:disabled</td>
<td>选择匹配E的所有不可用UI元素。</td>
</tr>
<tr>
<td>E:checked</td>
<td>选择匹配E的所有可用UI元素。<br />
            例：input:checked匹配input type为radio及checkbox元素
            </td>
</tr>
</tbody>
</table>
<h1>6. CSS3其他选择器</h1>
<table>
<tbody>
<tr>
<th>选择器</th>
<th>说明</th>
</tr>
<tr>
<td>E~F</td>
<td>通用兄弟元素选择器类型。<br />
            选择匹配F的所有元素，且匹配元素位于匹配E的元素后面。<br />
            在DOM结构树中，E和F所匹配的元素应该在同一级结构上。
            </td>
</tr>
<tr>
<td>E:not(s)</td>
<td>
                否定伪类选择器类型。<br />
                选择匹配E的所有元素，且过滤掉匹配s选择符的任意元素。<br />
                s是一个简单结构的选择器，不能使用符合选择器，
            </td>
</tr>
<tr>
<td>E:target</td>
<td>目标伪类选择器类型。<br />
            选择匹配E的所有元素，且匹配元素被相关URL指向。<br />
            注意：该选择器是动态选择器，只有存在URL指向该匹配元素时，样式才起效果。<br />
            例：demo.html#id
            </td>
</tr>
</tbody>
</table>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j17ng9.html">1Z0-053 争议题目解析212</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gldvzq.html">【OpenStack】OpenStack系列16之OpenStack镜像制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e13w7e9.html">Oracle中存储过程传入表名学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdxw3k8.html">boost总结之any</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2emz9.html">带计时器的做题器（gui</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yedweq.html">最近比较迷flash professional cc 做PPT，做一个flash做动态打字效果的教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mem1vrq.html">基于visual Studio2013解决算法导论之002归并排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wzp2q.html">欢迎大家关注我的微信公众帐号小q机器人&lpar;xiaoqrobot&rpar;（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zxppe9.html">12&period;5&period;3 UNIVERSAL：最终的祖先类&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey4kez9.html">vj1011&colon;记忆化搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyrg1m9.html">实现基于Keepalived主从高可用集群网站架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kor559.html">【Bootstrap】bootstrap-datetimepicker日期时间插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k75p49.html">浅谈HTTP协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eynkxe9.html">记录CentOS 7&period;4 上安装MySQL&amp;amp&semi;MariaDB&amp;amp&semi;Redis&amp;amp&semi;Mongodb</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z43pj9.html">&lbrack;物理学与PDEs&rsqb;第2章习题4 习题 3 的变分</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5yrxq.html">前端之html、css</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy4xe39.html">Elasticsearch跨集群搜索&lpar;Cross Cluster Search&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9601wg39.html">有人在用fastReport作报表时处理过字体自动缩小的问题吗，怎么做</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4ny0pq.html">&lbrack;Usaco2005 Open&rsqb;Disease Manangement 疾病管理 BZOJ1688</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjn4xr8.html">java基础学习总结&mdash;&mdash;GUI编程&lpar;二&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4z0oe9.html">java与javac命令的功用</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxkv1v8.html">1&period; Activiti 运行时表信息总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zo0gxq.html">&lbrack;RxJava&Hat;Android&rsqb;项目经验分享 --- 递归实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kpx159.html">插头dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnjpex8.html">oracle表空间简单学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqljg5x9.html">window&period;onload和&dollar;&lpar;document&rpar;&period;ready&lpar;function&lpar;&rpar;&lbrace;&rcub;&rpar;的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96p11n8.html">ADO&period;NET数据访问模板整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pwn148.html">sql编程（四）触发器</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q25wmxq.html">学习 React&lpar;jsx语法&rpar; &plus; es2015 &plus; babel &plus; webpack</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdnxd9.html">daima</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
